; Universaltreiber zu Ansteuerung von IC-Bus-Bausteinen
; ber den internen IC-Bus der C-Control I V1.1 (68HC05B6/B16)
; - PCF8574
; - Bausteine mit Byte-Adress-Register
; - Bausteine mit Word-Adress-Register
; Einsprungaddressen:
; - schreiben &h101
; - lesen     &h121

i2c_start equ $083C
i2c_write equ $0846
i2c_read  equ $086F
i2c_readlast equ $08BB
i2c_stop  equ $08E5
ReadEEByte equ $0e04

	org $101
; PCF8574 setzen
setpcf  bsr coni2c
        ldx $94
        bra wrlast

; PCF8574 lesen
getpcf  bsr coni2c
rdByte  jsr i2c_read
        sta $92
        jsr i2c_readlast
coneeprom 
        ldx #$0A0
        bsr i2cstrt
        ldx $066
        jsr i2c_write
        ldx $067
        jsr i2c_write
        ldx #$0A1
        bra i2cstrt
       
        
; Byte an Baustein mit Byte-Addr.Register schreiben
WrBBReg bsr coni2c
WRLSBA
        ldx $94
WRLSB        
        bsr i2cwr
        ldx $96
wrlast        
        bsr i2cwr
        bra wrstp

; Word an Baustein mit Byte-Addr.Register schreiben
WrWBReg bsr coni2c
WRMSBA
        ldx $94
        bsr i2cwr
        ldx $95
        bra WRLSB

; Byte an Baustein mit Word-Addr.Register schreiben
WrBWReg bsr coni2c
        ldx $93
        bsr i2cwr
        bra WRLSBA

; Word an Baustein mit Word-Addr.Register schreiben
WrWWReg bsr coni2c
        ldx $93
        bsr i2cwr
        bra WRMSBA

;
coni2c  jsr i2c_readlast
        ldx $92
i2cstrt jmp i2c_start

        
Rstrt   ldx $94
        bsr i2cwr
        lda $92
        ora #1
        tax
        bra i2cstrt

; Byte von Baustein mit Byte-Addr.Register lesen
RdBBReg bsr coni2c
RdB     bsr Rstrt
        bra rdByte
        
; Word von Baustein mit Byte-Addr.Register lesen
RdWBReg bsr coni2c
RdW     bsr Rstrt
        jsr i2c_read
        sta $91
        bra rdByte

; Byte von Baustein mit Word-Addr.Register lesen
RdBWReg bsr coni2c
        ldx $93
        bsr i2cwr
        bra RdB
        
; Word von Baustein mit Word-Addr.Register lesen
RdWWReg bsr coni2c
        ldx $93
        bsr i2cwr
        bra RdW
        
;----------------------------------------------------
;PCFLCD
cmd     bsr get96
        ora #$04
sta96        
        bsr lcdstrt
        bsr writenibble
        lda $94
        asla
        asla
        asla
        asla
wrlnib
        bsr writenibble
wrstp        
        jsr i2c_stop
        bra coneeprom

writenibble
        and #$F0
        ora $96 ;register fr LCD-Beleuchtung, RS, R/W
        tax
        and #$FB
        sta $93
        bsr i2cwr
        ldx $93
i2cwr        
        jmp i2c_write

char    bsr get96
        ora #$05
        bra sta96

cmd8    bsr get96
        ora #$04
        bsr lcdstrt
        bra wrlnib

get96   jsr i2c_readlast
        lda $96
        and #$08
        rts
lcdstrt
        sta $96
        ldx $92
        bsr i2cstrt
        lda $94
        rts
                
print:
	jsr ReadEEByte
	bra getchar
printchar:
        bsr char
getchar:
	jsr ReadEEByte
	sta $94
	bne printchar
	rts


