'--------------------------------------------------------------
'Ansteuereungsbeispiele fr SAA1064 / I2C-7Seg4
' mit IC-Bus-Multitreiber "int_i2c.s19"
'CCTools 2004 http://cctools.hs-control.de (04.09.2004)
'--------------------------------------------------------------
' Zeit und Datumsausgabe ber I2C-7Seg4
'--------------------------------------------------------------

'--------------------------------------------------------------
'Einsprungadressen von "int_i2c.s19" Release 19.09.04
'--------------------------------------------------------------
' PCF8574:
define PCFwrite   &h101
define PCFread    &h107
'--------------------------------------------------------------
' Bausteine mit Byte-Adress-Register
define WrByteBReg &h123
define WrWordBReg &h12F
define RdByteBReg &h15C
define RdWordBReg &h162
'--------------------------------------------------------------
' Bausteine mit Word-Adress-Register
define WrByteWReg &h139
define WrWordWReg &h141
define RdByteWReg &h16D
define RdWordWReg &h175
'--------------------------------------------------------------
' PCFLCD:
define putCmd8Bit &h1a9
define putCmd     &h17D
define putChar    &h1a3
define prnLCD     &h1C2
'--------------------------------------------------------------


Define Dot   &b10000000
Define Minus &b01000000

define SAA1064 112 'Adresse des SAA1064. Alternativ kann auch eine Variable benutzt werden.

define pop DA[1] 'Trick zum Auslesen des Stacks(siehe ccintern.dharlos.de)

define cmd Byte[1]  ' Byte zur Parameterbergabe
define data Byte[2] ' Byte zur Parameterbergabe
define temp Byte[3]

hour=12
minute=30
day=4
month=9

gosub initSAA

#loop
 cmd=1 ' 1.Ziffer (von links)
 data=hour/10
 gosub write_digit
 cmd=2 ' 2.Ziffer (von links)
 data=(hour mod 10) or Dot 'Dezimal-Punkt zwischen zweiter und dritter Ziffer
 gosub write_digit
 cmd=3 ' 3.Ziffer (von links)
 data=minute / 10
 gosub write_digit
 cmd=4 ' 4.Ziffer (von links)
 data=minute mod 10
 gosub write_digit

 pause 75
 cmd=1 ' 1.Ziffer (von links)
 data=day/10
 gosub write_digit
 cmd=2 ' 2.Ziffer (von links)
 data=(day mod 10) or Dot 'Dezimal-Punkt zwischen zweiter und dritter Ziffer
 gosub write_digit
 cmd=3 ' 3.Ziffer (von links)
 data=month / 10
 gosub write_digit
 cmd=4 ' 4.Ziffer (von links)
 data=(month mod 10) or Dot 'Dezimal-Punkt hinter letzter Ziffer
 gosub write_digit

 pause 75
goto loop

#initSAA
 sys WrByteBReg,&b00110111,0,SAA1064 'Statusregister
               ' 9mA, 4 7Segment-LEDs
 sys WrWordBReg,0,1,SAA1064 ' LEDs aus
 sys WrWordBReg,0,3,SAA1064 ' LEDs aus
return

#write_digit
 looktab SAAdigit, (data and 15), temp
 data=temp or (data and &hF0)
 sys WrByteBReg,data,cmd,SAA1064 'Statusregister
return

table SAAdigit 'Bitmuster fr Segmente
&b0111111 &b0000110 &b1011011 &b1001111 '0,1,2,3
&b1100110 &b1101101 &b1111101 &b0000111 '4,5,6,7
&b1111111 &b1101111 &b1110111 &b1111100 '8,9,A,B
&b0111001 &b1011110 &b1111001 &b1110001 'C,D,E,F
tabend

syscode "int_i2c.s19" 'nur einmal laden, dann auskommentieren
